#!/usr/bin/perl -w

# LSB Test Execution Framework
# Browse for RPM Package Module (choose_pkg.pl)
#
# Copyright (C) 2007-2008 The Linux Foundation. All rights reserved.
#
# This program has been developed by ISP RAS for LF.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# version 2 as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

use Templates;

my $packager = ($is_packager_rpm ? "RPM" : "DEB");

print "HTTP/1.0 200 OK\n";
print "Content-type: text/html\n\n";

if (!$_GET{"_frame"}) {
	my $args = "";
	foreach my $arg (sort keys %_GET) {
		my $value = $_GET{$arg};
		escape($arg);
		escape($value);
		$args .= "&$arg=$value";
	}
	print <<DATA;
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Frameset//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-frameset.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en" dir="ltr">

<head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <title>RPM Packages</title>
</head>

<frameset rows="*, 60">
  <frame src="choose_pkg.pl?_frame=top$args" name="top_frame" id="top_frame" />
  <frame src="choose_pkg.pl?_frame=bottom" name="bottom_frame" id="bottom_frame" scrolling="no" />
  <noframes>
    <body><h1 style="color: red;">Your browser does not support frames!</h1></body>
  </noframes>
</frameset>
</html>
DATA
}
elsif ($_GET{"_frame"} eq "bottom") {
	print <<DATA;
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en" dir="ltr">

<head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <title></title>
</head>

<body>
<table cellpadding="0" cellspacing="0" border="0" width="100%">
  <tr>
    <td align="right">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td height="40" style="width: 10em; text-align: left;">Selected packages: <span id="num_pkg">...</span></td>
          <td><img src="images/environment-spacer.gif" width="10" height="1" alt="" /></td>
          <td><input type="button" value="Finish" style="border: 1px solid black; background: white; width: 8em; font-weight: bold;" onclick="javascript:put_to_list();" /></td>
          <td><img src="images/environment-spacer.gif" width="10" height="1" alt="" /></td>
        </tr>
      </table>
    </td>
  </tr>
</table>

<script language="javascript" type="text/javascript">
// <![CDATA[
function put_to_list() {
	if (parent.opener) {
		var elem = parent.opener.document.getElementById("packages");
		var arr = parent.top_frame.document.getElementsByTagName('td');
		var first_elem = '';
		if (elem && arr) {
			var to_add = '';
			for (var i=0; i<arr.length; ++i) {
				if (arr[i].className == 'selected') {
					var tmp;
					if (typeof(arr[i].innerText) == "undefined")
						tmp = arr[i].textContent;
					else
						tmp = arr[i].innerText;
					to_add += tmp + '\\n';
					if (first_elem == '')
						first_elem = tmp;
				}
			}
			elem.value = to_add;
		}
		var app_name = parent.opener.document.getElementById('application');
		if (app_name && (app_name.value == '')) {
			app_name.value = first_elem;
		}
	}
	parent.window.close();
}

// ]]>
</script>

</body>
</html>
DATA
}
elsif ($_GET{"_frame"} eq "top") {
print <<DATA;
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en" dir="ltr">

<head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <title></title>
  <style type="text/css">
	table.main {
		border: 0px solid black;
		border-collapse: collapse;
	}
	table.main td, table.main th {
		border: 1px solid black;
		padding: 4px;
		white-space: nowrap;
	}
	table.main td {
		font-family: monospace;
		font-size: 10pt;
	}
	table.main td.selected {
		color: red;
	}
	tr.list_item0 {
		background: #e7e7e7;
	}
	tr.list_item1 {
		background: #ffffff;
	}
	tr.clickable:hover {
		background-color: #d0d0ff;
		cursor: pointer;
	}
	td h3 {
		margin-top: 10px;
		margin-bottom: 0px;
	}
  </style>
</head>

<body>

<script language="javascript" type="text/javascript">
// <![CDATA[
var num_pkg = 0;
function check_unckeck(id, update_chk) {
	var chkbox = document.getElementById('chk-' + id);
	var pkgname = document.getElementById('pkg-' + id);
	if (chkbox && pkgname) {
		if (update_chk) {
			if (chkbox.checked) {
				chkbox.checked = false;
				pkgname.className = '';
				--num_pkg;
			}
			else {
				chkbox.checked = true;
				pkgname.className = 'selected';
				++num_pkg;
			}
		}
		else {
			if (chkbox.checked) {
				pkgname.className = 'selected';
				++num_pkg;
			}
			else {
				pkgname.className = '';
				--num_pkg;
			}
		}
		set_num_pkg(num_pkg);
	}
}

function set_num_pkg(value) {
	var elem = parent.bottom_frame.document.getElementById("num_pkg");
	if (elem)
		elem.innerHTML = value;
}

// ]]>
</script>

<table border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr>
    <td align="left" width="100%"><h3>Select Installed $packager Packages:</h3></td>
    <td><img src="images/environment-spacer.gif" width="10" height="1" border="0" alt="" /></td>
    <td align="right"><h3><a href="tests_help.pl#browse_pkg" target="_blank">Help</a></h3></td>
  </tr>
</table>
DATA

my @packages = split(/\n/, ($is_packager_rpm ?
	`rpm -qa --qf "\%\{NAME\}\\t\%\{VERSION\}\\t\%\{RELEASE\}\\n" | sort` :
	`dpkg-query -W -f '\${Package}\t\${Version}\t\${Status}\n' | sort`
));

my $odd_line = 0;
my $table_data = "";

delete $_GET{"_frame"};
my $num_pkg = 0;
if ($is_packager_rpm) {
	$table_data = <<DATA;
<table class="main">
  <tr>
    <th width="30"></th>
    <th style="width: 20em;">Name</th>
    <th>Version</th>
    <th>Release</th>
  </tr>
DATA
	foreach my $pkg (@packages) {
		my ($name, $ver, $rel) = split(/\t/, $pkg, 3);
		next if ($name eq "gpg-pubkey");
		my $checked = "";
		my $selected = "";
		if ($_GET{$name}) {
			$checked = " checked=\"checked\"";
			$selected = " class=\"selected\"";
			++$num_pkg;
			delete $_GET{$name};
		}
		my $name_id = "$name-$ver-$rel";
		$name_id =~ s/\+/p/g;
		$name_id =~ s/~/-/g;
		$table_data .= <<DATA;
  <tr class="list_item$odd_line clickable">
    <td align="center"><input type="checkbox" id="chk-$name_id"$checked onclick="javascript:check_unckeck('$name_id', false);" /></td>
    <td id="pkg-$name_id"$selected onclick="javascript:check_unckeck('$name_id', true);"><b>$name</b></td>
    <td onclick="javascript:check_unckeck('$name_id', true);">$ver</td>
    <td onclick="javascript:check_unckeck('$name_id', true);">$rel</td>
  </tr>
DATA
		$odd_line = 1 - $odd_line;
	}
}
else {
	$table_data = <<DATA;
<table class="main">
  <tr>
    <th width="30"></th>
    <th style="width: 20em;">Name</th>
    <th>Version</th>
  </tr>
DATA
	foreach my $pkg (@packages) {
		my ($name, $ver, $st) = split(/\t/, $pkg, 3);
		next if ($st ne "install ok installed");
		my $checked = "";
		my $selected = "";
		if ($_GET{$name}) {
			$checked = " checked=\"checked\"";
			$selected = " class=\"selected\"";
			++$num_pkg;
			delete $_GET{$name};
		}
		my $name_id = "$name-$ver";
		$name_id =~ s/\+/p/g;
		$name_id =~ s/~/-/g;
		$table_data .= <<DATA;
  <tr class="list_item$odd_line clickable">
    <td align="center"><input type="checkbox" id="chk-$name_id"$checked onclick="javascript:check_unckeck('$name_id', false);" /></td>
    <td id="pkg-$name_id"$selected onclick="javascript:check_unckeck('$name_id', true);"><b>$name</b></td>
    <td onclick="javascript:check_unckeck('$name_id', true);">$ver</td>
  </tr>
DATA
		$odd_line = 1 - $odd_line;
	}
}

$table_data .= "</table>\n";

my $absent_packages = "<br />\n";
if (scalar(keys %_GET) > 0) {
	$absent_packages = join("</li>\n  <li>", keys %_GET);
	$absent_packages = <<DATA;
<br />
<div style="color: red;"><b>The following packages are selected but not installed:</b>
<ul>
  <li>$absent_packages</li>
</ul>
</div>
DATA
}

print <<DATA;
$absent_packages
$table_data

<script language="javascript" type="text/javascript">
// <![CDATA[
num_pkg = $num_pkg;
set_num_pkg(num_pkg);
// ]]>
</script>

</body>
</html>
DATA
}
else {
	print <<DATA;
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en" dir="ltr">

<head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <title>Error</title>
</head>

<body>
<h2 style="color: red;">Wrong "_frame" argument!</h2>
</body>
</html>
DATA
}
